// ------------------------------------------------------
// ...
// ------------------------------------------------------

// Changes because of div. wifi-problems
// look at: http://www.phoneds.com/?p=6

// Includes
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>

#include <nds.h>
#include <PA9.h>       // Include for PA_Lib
#include <fat.h>

#include <malloc.h>

#include <stdlib.h>

// wifi
#include <dswifi9.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

//needed to load pcx files
#include <nds/arm9/image.h>
#include <nds/arm9/trig_lut.h>

  
// add Raw-Sound
#include "soundCry.h" // in /data - folder
#include "soundSabber.h"

#include "soundC.h"
#include "soundD.h"
#include "soundE.h"
#include "soundF.h"
#include "soundG.h"
#include "soundA.h"
#include "soundH.h"
#include "soundB.h"

	#include "soundCLong.h"
	#include "soundDLong.h"
	#include "soundELong.h"
	#include "soundFLong.h"
	#include "soundGLong.h"
	#include "soundALong.h"
	#include "soundHLong.h"
	#include "soundBLong.h"

#include "soundCC.h"
#include "soundDD.h"
#include "soundEE.h"
#include "soundFF.h"
#include "soundGG.h"
#include "soundAA.h"
#include "soundHH.h"
#include "soundBB.h"

	#include "soundCCLong.h"
	#include "soundDDLong.h"
	#include "soundEELong.h"
	#include "soundFFLong.h"
	#include "soundGGLong.h"
	#include "soundAALong.h"
	#include "soundHHLong.h"
	#include "soundBBLong.h"

#include "soundP.h"
 
// sprites
#include "gfx/all_gfx.h"
#include "gfx/all_gfx.c"  

// -------------------------------------------------------
// applicationStatus
// -------------------------------------------------------
char applicationStatus[255];
char applicationStatusSub[255];
char applicationArgument[255];

// avatar
int avatarX=0;
int avatarY=0;

// ---------------------------------------
// wifi
// ---------------------------------------
Wifi_AccessPoint ap;
Wifi_AccessPoint global_connectAP;
unsigned char global_wepkeys[4][32];
int global_wepkeyid, global_wepmode;
int global_dhcp; // 0=none, 1=get IP&dns, 2=get IP&not dns
unsigned long global_ipaddr, global_snmask, global_gateway, global_dns1,global_dns2;

char renderbuf[64];
int numaps,i,j,k,add;
int scrolltop;
int basetouchy,basetouchscroll,basetouchnumaps;

 
 // ap (access point)
 struct ApObject
 {
	// stringid
	char stringId[255];

	// sound
	char sound[255]; // avaliable sounds
	
	// display
	int x;
	int y;
	
	// selected
	int selected; 

	// pro
	int pro;
	
	// order
	int order;
	
 } apObjectArray[1000];
 int apObjectArrayMax=1000;
 int apObjectArrayCount=0;
 
	 // actions
	 struct ActionObject
	 {
		// stringid
		char stringId[255];

		char stringAction[255];
		char stringActionSub[255];
		char stringPeriod[255];
		char stringArgument[255];
		char stringArgumentSub[255];
			
		int compare; // 0: = -1: < +1: > 
	
		// pro
		int pro;

		int done; // always done
		int doneTemp; // for entering/exit/...

		// display
		int x;
		int y;


		
	 } actionObjectArray[1000];
	 int actionObjectArrayMax=1000;
	 int actionObjectArrayCount=0;

// -------------------------------------------------------
// stringHiddenRaySong
// -------------------------------------------------------
char stringHiddenRaySongnotation1[255];
char stringHiddenRaySongnotation2[255];

	// settings
	int songSpeed=3;
	int song1DisplayFlag=1;
	int song2DisplayFlag=1;
	int songNotesDisplay=1;
	int songAllHotspots=0; // display all spots
	
	int songDisplayY=20;
	
	// temp hidden raysong things
	char stringHiddenRaySong[255];
	int intHiddenRaySongId=-1;
	char stringHiddenBuffer[255];
	int hiddenRAySongCounter1=0;
	int hiddenRAySongCounter2=0;
	int hiddenRaySpeed=10;
	
// Function: main()
int main(int argc, char ** argv)
{
	// 
	int sekrit_counter;
	IPC->mailData=0;
	IPC->mailSize=0;

	// ---------------------------------------
	// hiddenRaySong
	// ---------------------------------------
	sprintf(stringHiddenRaySongnotation1,"  waiting actual hotspots");
	sprintf(stringHiddenRaySongnotation2,"   back in time walked ");
	sprintf(stringHiddenRaySong,"         ");
	sprintf(stringHiddenBuffer,"         ");
		if (false)
		{
			sprintf(stringHiddenRaySongnotation1," ");
			sprintf(stringHiddenRaySongnotation2,"   ");
			sprintf(stringHiddenRaySong,"   ");
			sprintf(stringHiddenBuffer,"   ");
		}
		
	// ---------------------------------------
	// hotspots
	// ---------------------------------------
	// generate some objects
		if (false)
		{
			sprintf(apObjectArray[apObjectArrayCount].stringId,"Petra");
			apObjectArray[apObjectArrayCount].x=3;
			apObjectArray[apObjectArrayCount].y=3;
			apObjectArray[apObjectArrayCount].pro=15;
			apObjectArray[apObjectArrayCount].order=-1;
			// sprintf(buf,"port %i",portnum);
			apObjectArrayCount++;
		
			sprintf(apObjectArray[apObjectArrayCount].stringId,"teletone");
			apObjectArray[apObjectArrayCount].x=3;
			apObjectArray[apObjectArrayCount].y=7;
			apObjectArray[apObjectArrayCount].pro=30;
			apObjectArray[apObjectArrayCount].order=-1;
			apObjectArray[apObjectArrayCount].selected=0;
			// sprintf(buf,"port %i",portnum);
			apObjectArrayCount++;

			sprintf(apObjectArray[apObjectArrayCount].stringId,"Zyxel");
			apObjectArray[apObjectArrayCount].x=3;
			apObjectArray[apObjectArrayCount].y=7;
			apObjectArray[apObjectArrayCount].pro=40;
			apObjectArray[apObjectArrayCount].order=-1;
			apObjectArray[apObjectArrayCount].selected=0;
			// sprintf(buf,"port %i",portnum);
			apObjectArrayCount++;

			sprintf(apObjectArray[apObjectArrayCount].stringId,"rio");
			apObjectArray[apObjectArrayCount].x=3;
			apObjectArray[apObjectArrayCount].y=7;
			apObjectArray[apObjectArrayCount].pro=10;
			apObjectArray[apObjectArrayCount].order=-1;
			apObjectArray[apObjectArrayCount].selected=0;
			// sprintf(buf,"port %i",portnum);
			apObjectArrayCount++;

		
			sprintf(apObjectArray[apObjectArrayCount].stringId,"kiff kaff");
			apObjectArray[apObjectArrayCount].x=3;
			apObjectArray[apObjectArrayCount].y=7;
			apObjectArray[apObjectArrayCount].pro=4;
			apObjectArray[apObjectArrayCount].order=-1;
			apObjectArray[apObjectArrayCount].selected=0;
			// sprintf(buf,"port %i",portnum);
			apObjectArrayCount++;

			sprintf(apObjectArray[apObjectArrayCount].stringId,"Wire lan");
			apObjectArray[apObjectArrayCount].x=3;
			apObjectArray[apObjectArrayCount].y=7;
			apObjectArray[apObjectArrayCount].pro=5;
			apObjectArray[apObjectArrayCount].order=-1;
			apObjectArray[apObjectArrayCount].selected=0;
			// sprintf(buf,"port %i",portnum);
			apObjectArrayCount++;

			sprintf(apObjectArray[apObjectArrayCount].stringId,"Jules");
			apObjectArray[apObjectArrayCount].x=3;
			apObjectArray[apObjectArrayCount].y=7;
			apObjectArray[apObjectArrayCount].pro=0;
			apObjectArray[apObjectArrayCount].order=-1;
			apObjectArray[apObjectArrayCount].selected=0;
			// sprintf(buf,"port %i",portnum);
			apObjectArrayCount++;

			int oo=0;
			if (true)
			for (oo=0;oo<12;oo++)
			{
					sprintf(apObjectArray[apObjectArrayCount].stringId,"THDCAD %d",oo);
					apObjectArray[apObjectArrayCount].x=3;
					apObjectArray[apObjectArrayCount].y=7;
					apObjectArray[apObjectArrayCount].pro=0;
					apObjectArray[apObjectArrayCount].order=-1;
					apObjectArray[apObjectArrayCount].selected=0;
					// sprintf(buf,"port %i",portnum);
					apObjectArrayCount++;
			}
		}
			
	// do them all
	int d=0;
	for (d=0;d<apObjectArrayCount;d++)
	{
		// ...
		
	}
	
	// ---------------------------------------
	// actions
	// ---------------------------------------
	// generate some objects
	// add("spotx",1,0,"always","playsound","soundCry");
	// add("spotx",1,0,"enter","print","go away");
	// add("spotx",1,0,"exit","print","go away");
	// add("spotx&spoty",1,0,"playsound","soundCry");
	// ** add("timer",0,0,"playsound","comeongo");
	// triangulation
	
			actionObjectArray[actionObjectArrayCount].done=0;
			sprintf(actionObjectArray[actionObjectArrayCount].stringId,"portz");
			actionObjectArray[actionObjectArrayCount].compare=1;
			actionObjectArray[actionObjectArrayCount].pro=0;
			sprintf(actionObjectArray[actionObjectArrayCount].stringAction,"playsound");
			// sprintf(actionObjectArray[actionObjectArrayCount].stringActionSub,"sound");
			// sprintf(actionObjectArray[actionObjectArrayCount].stringPeriod,"always");
			sprintf(actionObjectArray[actionObjectArrayCount].stringArgument,"soundSabber");
			//	sprintf(actionObjectArray[actionObjectArrayCount].stringArgumentSub,"");
			actionObjectArrayCount++;
		
			actionObjectArray[actionObjectArrayCount].done=0;
			sprintf(actionObjectArray[actionObjectArrayCount].stringId,"portxy");
			actionObjectArray[actionObjectArrayCount].compare=1;
			actionObjectArray[actionObjectArrayCount].pro=0;
			sprintf(actionObjectArray[actionObjectArrayCount].stringAction,"printtext");
			// sprintf(actionObjectArray[actionObjectArrayCount].stringActionSub,"sound");
			// sprintf(actionObjectArray[actionObjectArrayCount].stringPeriod,"always");
			sprintf(actionObjectArray[actionObjectArrayCount].stringArgument,"port..port..port");
			//	sprintf(actionObjectArray[actionObjectArrayCount].stringArgumentSub,"");
			actionObjectArrayCount++;
		
			actionObjectArray[actionObjectArrayCount].done=0;
			sprintf(actionObjectArray[actionObjectArrayCount].stringId,"Jules");
			actionObjectArray[actionObjectArrayCount].compare=1;
			actionObjectArray[actionObjectArrayCount].pro=0;
			sprintf(actionObjectArray[actionObjectArrayCount].stringAction,"playsound");
			// sprintf(actionObjectArray[actionObjectArrayCount].stringActionSub,"sound");
			// sprintf(actionObjectArray[actionObjectArrayCount].stringPeriod,"always");
			sprintf(actionObjectArray[actionObjectArrayCount].stringArgument,"soundDie");
			//	sprintf(actionObjectArray[actionObjectArrayCount].stringArgumentSub,"");
			actionObjectArrayCount++;

	
	// do them all
	for (d=0;d<actionObjectArrayCount;d++)
	{
		// ...
		// actionObjectArray[d].
	}
		
	// init 3d
	// no sprites on bottom screen
		// Turn on everything
	// powerON(POWER_ALL);



	// INIT
	PA_Init(); 
	PA_InitVBL(); 

/*
	// !!!!!
	
	// Setup the Main screen for 3D 
	videoSetMode(MODE_0_3D);
		// initialize the geometry engine
		
	glInit();
	
	// enable antialiasing
	glEnable(GL_ANTIALIAS);
	
	// setup the rear plane
	glClearColor(0,0,0,31); // BG must be opaque for AA to work
	glClearPolyID(63); // BG must have a unique polygon ID for AA to work
	glClearDepth(0x7FFF);
	
	// Set our viewport to be the same size as the screen
	glViewPort(0,0,255,191);
	
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(35, 256.0 / 192.0, 0.1, 100);
	
	// Set the color of the vertices
	glColor3f(1, 1, 1);

// !!!!


*/	
  
	// switch
	// lcdSwap();
	
 	// PA_Init();    // Initializes PA_Lib
	// PA_InitVBL(); // Initializes a standard VBL

	// ------------------------------------------
	// Display Text
	// ------------------------------------------
	// initText(0:bottom 1: top
	// 	PA_InitText(WHICHSCREEN,0);
	PA_InitText(1,0);
    PA_SetTextCol(1,5,5,5); 
	// PA_OutputSimpleText(SCREEN,X,Y,TEXT);
    /*
	PA_OutputSimpleText(1,0,0,"  oOOOOooooooo ");
    PA_OutputSimpleText(1,0,1,"  oOOooOOOooooooo ");
    PA_OutputSimpleText(1,0,2," oOOoOooooooo ");
	*/

	// Text on screen below
	PA_InitText(0,0);
	// PA_SetTextCol(0,5,5,5); 
	// PA_OutputSimpleText(SCREEN,X,Y,TEXT);
	// PA_SetTextTileCol(0,2); 
	// PA_SetTextTileCol(1, n); sets the text color for the new texts to n... nothing less, nothing more. n can take values from 0 to 9 ( 0 = white, 1 = red, 2 = green, 3 = blue, 4 = purple, 5 = cyan, 6 = yellow, 7 = light grey, 8 = dark grey, 9 = black
    /*
	PA_OutputSimpleText(0,0,0,"  oOOOOooooooo ");
    PA_OutputSimpleText(0,0,1,"  oOOoOOOOOOooooooo ");
    PA_OutputSimpleText(0,0,2," oOOoooooooooooo ");
	*/
	
	// Get Text from Keyboard
	/*
		char text[200];
		getTextboard(text);
		PA_OutputSimpleText(1,0,2,text  );
	*/
	
	// Random
	PA_InitRand();
	u32 num = PA_RandMinMax(1,4);
	
	// SoundInit
	PA_InitSound();  // Init the sound system
	// PA_PlaySimpleSound(0, soundCry); // play sound 

	// ------------------------------------------
	// LOAD SPRITE
	// ------------------------------------------
/*
		PA_LoadSpritePal(0, // Screen
			0, // Palette number
			(void*)spritebgif_Pal);	// Palette name
*/					
/*	PA_CreateSprite(0, // Screen
			0, // Sprite number
			(void*)spritebgif_Sprite, // Sprite name 
			OBJ_SIZE_64X64, // Sprite size
			1, // 256 color mode
			0, // Sprite palette number
			200, 30); // X and Y position on the screen

	// rotating
	PA_SetSpriteRotEnable(0,// screen
		      0,// sprite number
		      0);// rotset number. You have 32 rotsets (0-31) per screen. 2 sprites with*
                         // *the same rotset will be zoomed/rotated the same way...
*/
/*	PA_LoadSpritePal(1, // Screen
			0, // Palette number
			(void*)spritebgif_Pal);	// Palette name
*//*
	PA_CreateSprite(1, // Screen
			1, // Sprite number
			(void*)spritebgif_Sprite, // Sprite name
			OBJ_SIZE_64X64, // Sprite size
			1, // 256 color mode
			0, // Sprite palette number
			200, 100); // X and Y position on the screen
*/
//	PA_InitAllSpriteDraw();  // Inits the sprite draw mode, necessary for the pixel-perfect touch detection

	// generate a lot of sprites
	// int i=0;
	// for (i = 0; i < 16; i++) PA_CreateSprite(0, i,(void*)spritebgif_Sprite, OBJ_SIZE_64X64,1, 0, i << 4, i << 3);

	u16 angle = 0;

	// -------------------------------------------------------
	// wifi
	// -------------------------------------------------------
	   REG_IPC_FIFO_CR = IPC_FIFO_ENABLE | IPC_FIFO_SEND_CLEAR;

	u32 Wifi_pass= Wifi_Init(WIFIINIT_OPTION_USELED);
   REG_IPC_FIFO_TX=0x12345678;
    REG_IPC_FIFO_TX=Wifi_pass;
	
	*((volatile u16 *)0x0400010E) = 0;
	irqInit();
		// IRQ basic setup
	irqSet(IRQ_VBLANK, 0);

	irqSet(IRQ_TIMER3, Timer_50ms);
	irqEnable(IRQ_TIMER3);
    irqSet(IRQ_FIFO_NOT_EMPTY, arm9_fifo);
    irqEnable(IRQ_FIFO_NOT_EMPTY);
    REG_IPC_FIFO_CR = IPC_FIFO_ENABLE | IPC_FIFO_RECV_IRQ;
    Wifi_SetSyncHandler(arm9_synctoarm7);
	*((volatile u16 *)0x0400010C) = -6553; // 6553.1 * 256 cycles = ~50ms;
	*((volatile u16 *)0x0400010E) = 0x00C2; // enable, irq, 1/256 clock

	// set defaults
	global_connectAP.ssid_len=7;
	strcpy(global_connectAP.ssid,"linksys");
	global_connectAP.rssi=0;
	global_connectAP.channel=1;
	global_connectAP.flags=0;
	global_wepkeyid=0;
	global_wepmode=0;
	global_dhcp=1;
	global_ipaddr=0xBD01A8C0;
	global_snmask=0x00FFFFFF;
	global_gateway=0x0101A8C0;
	global_dns1=0x0101A8C0;
	global_dns2=0;

	// init wifi
	//PA_OutputSimpleText(1,0,6," Init Wifi        ");	
	while(Wifi_CheckInit()==0) { PA_WaitForVBL(); }
	// printbtm(3,5,"ARM7 Init Confirmed. _");
	//PA_OutputSimpleText(1,0,6," WIFI Init confirmed   ");
	
	Wifi_EnableWifi();

	// wifi
	Wifi_ScanMode();

	// ------------------------------------------------
	// Background
	// ------------------------------------------------
	PA_EasyBgLoad(1, // screen
					3, // background number (0-3)
					bg1); // Background name, used by PAGfx...
	PA_EasyBgLoad(0, // screen
					3, // background number (0-3)
					bg0); // Background name, used by PAGfx...
  
	// ------------------------------------------------
	// Read & Write
	// ------------------------------------------------
//	fatInitDefault(); //Initialise fat library
/*	
	// write
	FILE* testWrite = fopen ("hotspots.txt", "wb"); //wb = create/truncate & write 
	fwrite("Just writing text to a file :)", 30, 1, testWrite);
	fclose(testWrite);
	PA_OutputSimpleText(1, 1, 11, "Writing complete.");
*/
/*	// read
	FILE* testRead = fopen ("hotspotlevel.txt", "rb"); //rb = read
	char filetext[30]; 
	fread(filetext, 30, 1, testRead);
	fclose(testRead);
	// PA_OutputSimpleText(1, 1, 1, filetext);
	// PA_OutputSimpleText(1, 1, 13, "Reading complete.");
*/ 
	 
	// about the probject 
	// PA_OutputSimpleText(1, 0, 6, "Click&Play");
	PA_OutputSimpleText(1, 0, 23, "Hear the sound of wlan.  walk!!");
	PA_OutputSimpleText(0, 0, 23, "sniffjazzbox::and-or.ch & j.auer ");
 
	// string 
	char printbuf[255];
	char printbufcomp[255];

	// Infinite loop to keep the program running
	int i=0;
	while (1)
	{
		
		// -----------------------------------------
		// keys
		// -----------------------------------------
		scanKeys();

		// normal keys
		u16 keys = keysHeld();
		
		if((keys & KEY_UP)) 
		{	
			// rotateX += 3;
			// printf("up ");
		}
		if((keys & KEY_DOWN)) 
		{	
			// rotateX += 3;
			// printf("down ");
		}

		if((keys & KEY_A)) 
		{	
			// rotateX += 3;
			// printf("a - key\n");
		}
 
		if((keys & KEY_B)) 
		{	
			// rotateX += 3;
			// lcdSwap();
		}
		
		
		// ------------------------------------------------
		// menu & stylus
		// ------------------------------------------------
		PA_SetTextCol(0,2,2,2); 
		// display menu
		PA_OutputText(0,0,1,"[ ]adagio [ ]allegro [ ]presto");
			// set which type
			// settings
			if (songSpeed==2) PA_OutputText(0,1,1,"*");
			if (songSpeed==3) PA_OutputText(0,11,1,"*");
			if (songSpeed==4) PA_OutputText(0,22,1,"*");
	
		PA_OutputText(0,0,2,"[ ]instant [ ]environment ");
			if (song1DisplayFlag==1) { PA_OutputText(0,1,2,"*"); }
			if (song2DisplayFlag==1) { PA_OutputText(0,12,2,"*"); }

		PA_OutputText(0,0,3,"[ ]notes [ ]all hotspots");
			if (songNotesDisplay==1) { PA_OutputText(0,1,3,"*"); }
			if (songAllHotspots==1) { PA_OutputText(0,10,3,"*"); }
	
		// touch .. 	
		if(keysDown()&KEY_TOUCH) 
		{
			int stylusX=(float) touchReadXY().px;
			int stylusY=(float) touchReadXY().py;
			
			// songspeed
			if ((stylusY>7)&&(stylusY<16))
			{
				if (stylusX<80) 
				{	songSpeed=2;
					hiddenRaySpeed=20;
					PA_PlaySimpleSound(PA_GetFreeSoundChannel() , soundC);
				}
				if ((stylusX>80)&&(stylusX<160)) 
				{	songSpeed=3;
					hiddenRaySpeed=10;
					PA_PlaySimpleSound(PA_GetFreeSoundChannel() , soundD);
				}
				if (stylusX>160) 
				{	songSpeed=4;
					hiddenRaySpeed=7;
					PA_PlaySimpleSound(PA_GetFreeSoundChannel() , soundE);
				}
			}
			// song stream
			if ((stylusY>16)&&(stylusY<24))
			{
				PA_OutputText(1,1,songDisplayY,  "                                                               "); 
				PA_OutputText(1,1,songDisplayY+1,"                                                             "); 
			
				if (stylusX<80) 
				{
					if (song1DisplayFlag==0) { song1DisplayFlag=1; }
					else { song1DisplayFlag=0; }
					PA_PlaySimpleSound(PA_GetFreeSoundChannel() , soundH);
				}
				
				if (stylusX>80) 
				{						
					if (song2DisplayFlag==0) { song2DisplayFlag=1; }
					else { song2DisplayFlag=0; }
					PA_PlaySimpleSound(PA_GetFreeSoundChannel() , soundF);

				} 
			}

			// display note
			if ((stylusY>24)&&(stylusY<32))
			{
				if (stylusX<70) 
				{						
					if (songNotesDisplay==0) { songNotesDisplay=1; }
					else { songNotesDisplay=0; }
					// select this here 
					PA_PlaySimpleSound(PA_GetFreeSoundChannel() , soundD);
				}
				if (stylusX>70) 
				{						
					if (songAllHotspots==0) { songAllHotspots=1; }
					else { songAllHotspots=0; }
					// select this here 
					PA_PlaySimpleSound(PA_GetFreeSoundChannel() , soundE);
				}
				
			}
			
			// add a hotspot
			if (stylusY>42)
			{
				 int index=(stylusY-42)/8;
				 if (index<apObjectArrayMax)
				 {
					// add this ...
					int lenT=strlen(stringHiddenRaySongnotation1);
					if (lenT>20)
					{
						int a=0;
						for (a=0;a<20;a++)
						{
							stringHiddenRaySongnotation1[a]=stringHiddenRaySongnotation1[a];
						}
						stringHiddenRaySongnotation1[9]='\0';
					}
					sprintf(stringHiddenRaySongnotation1,"%s%s ",stringHiddenRaySongnotation1,apObjectArray[index].stringId);
				 
					// ... clear all
					int p=0;
					for (p=0;p<apObjectArrayMax;p++)
					{
						apObjectArray[p].selected=0;	
					}
					// select it
					apObjectArray[index].selected=1;	
					
					// select this here 
					PA_PlaySimpleSound(PA_GetFreeSoundChannel() , soundC);
					
				 }
			}
			

			/*
			// PA_OutputText(1,0,14,"Stylus ?? [%d,%d]  %d  ", stylusX, stylusY,angle);
			PA_SetDefaultSound(127,11025,0); // volume 127,11025, 16-bit 
			PA_PlaySimpleSound(1, soundP);
			*/
			
		}

		// -----------------------------------------
		// sort all hotspots 
		// -----------------------------------------
		
		int hotspotZeroIndex=0;
		
		// sort all hotspots for 
		// - name
		// - pro   
		int firstHotspotZero=0;
		for (d=0;d<(apObjectArrayCount-1);d++)
		{
			if (apObjectArray[d].pro<apObjectArray[d+1].pro)
			{
				apObjectArray[apObjectArrayMax-1]=apObjectArray[d+1];	
				apObjectArray[d+1]=apObjectArray[d];
				apObjectArray[d]=apObjectArray[apObjectArrayMax-1];
			}
			
			// get firt hotspot with Zero Percent
			if (firstHotspotZero==0)
			{
				if (apObjectArray[d].pro<3)
				{
					hotspotZeroIndex=d;
					firstHotspotZero=1;
				}
			}
		}
		
		
	  
		// -----------------------------------------
		// display all hotspots 
		// -----------------------------------------
			
		 
		PA_SetTextCol(0,20,20,20); 
		int maxRows=apObjectArrayCount;
			if (maxRows>18) maxRows=18;
			
			// clean up 
			for (d=0;d<maxRows;d++)
			{
				sprintf(printbuf,"                            ");
				PA_OutputText(0,0,5+d,printbuf);
			}
	
		for (d=0;d<maxRows;d++)
		{
			if (apObjectArray[d].selected==0) sprintf(printbuf,"%3d %s ",apObjectArray[d].pro,apObjectArray[d].stringId);
			if (apObjectArray[d].selected==1) sprintf(printbuf,"%3d*%s ",apObjectArray[d].pro,apObjectArray[d].stringId);
			PA_OutputText(0,5,5+d,printbuf);
		}	

		// -----------------------------------------
		// display all actions
		// -----------------------------------------
		if (false)
		for (d=0;d<actionObjectArrayCount;d++)
		{
			sprintf(printbuf,"%3d:%d:%d;%s(%s) ",actionObjectArray[d].pro,actionObjectArray[d].compare,actionObjectArray[d].done,actionObjectArray[d].stringId,actionObjectArray[d].stringAction); // actionObjectArray[d].stringArgument);
			PA_OutputText(0,10,0+d,printbuf);
		}

		// check for action
		int dd=0;
		for (dd=0;dd<apObjectArrayCount;dd++)
		{
			// sprintf(printbuf,"%3d:%s              ",apObjectArray[dd].pro,apObjectArray[dd].stringId);
			for (d=0;d<actionObjectArrayCount;d++)
			{
				// both strings are equal?
				if (actionObjectArray[d].done==0)
				{
					// look for special hotspotaction (generic or something like that)
					
					
					// found a hotspot
					if (strcmp(apObjectArray[dd].stringId,actionObjectArray[d].stringId)==0)
					{
						// 	sprintf(printbuf,"A"); // actionObjectArray[d].stringArgument);
						// PA_OutputText(0,9,0+d,"****");
						
						// playsound
						if (strcmp(actionObjectArray[d].stringAction,"playsound")==0)
						{
							// sounds
							if (strcmp(actionObjectArray[d].stringArgument,"soundCry")==0)
							{
								// PA_PlaySimpleSound(0, soundCry); // play sound 
							}
							if (strcmp(actionObjectArray[d].stringArgument,"soundSabber")==0)
							{
								// PA_PlaySimpleSound(0, soundSabber); // play sound 
							}
							
						}

						// printtext
						if (strcmp(actionObjectArray[d].stringAction,"printtext")==0)
						{
							PA_OutputText(0,1,12,actionObjectArray[d].stringArgument);
						}
						
						// loadbackground
						if (strcmp(actionObjectArray[d].stringAction,"loadbackground")==0)
						{
							PA_OutputText(0,1,12,actionObjectArray[d].stringArgument);
						}
						
						// if period==once ... 
						actionObjectArray[d].done=1;
						
						// different action things place here
						
						
						
					}
				}
			}
		}

		// -----------------------------------------
		// display all active hotspots
		// -----------------------------------------
		// PA_OutputText(0,0,10,"Hotspots found [%d] ", Wifi_GetNumAP());
			// reset all pro
			for (dd=0;dd<apObjectArrayCount;dd++)
			{
				apObjectArray[dd].pro=0;
			}		
			
		// search thorugh
		int num=Wifi_GetNumAP();
		int counterOverZero=0;
		for(i=0;i<num;i++)
		{
			if(Wifi_GetAPData(i+scrolltop,&ap)==WIFI_RETURN_OK) 
			{
				int j='-';
				if(ap.flags&WFLAG_APDATA_COMPATIBLE) j='+';
				if(ap.flags&WFLAG_APDATA_EXTCOMPATIBLE) j='?';
				// we have 28 characters to work with
				//               "01 23456 789ABCDEF0123456789AB"
				// PA_OutputText(1,8,5+i,"C%cS%3i%%:%20s",j,(ap.rssi*100)/0xD0,ap.ssid);
				int pro=(ap.rssi*100)/0xD0;
				// display all
				// sprintf(printbuf,"%cS%3i%%:%s            ",j,(ap.rssi*100)/0xD0,ap.ssid,pro);
				//PA_OutputText(1,8,5+i,printbuf);
				int insertThis=0;
				if (songAllHotspots==0) { if (pro>0) insertThis=1; } 
				if (songAllHotspots==1) { insertThis=1; } 

				if (insertThis==1)
				{
					// check for new entries
					int found=-1;
					for (dd=0;dd<apObjectArrayCount;dd++)
					{
						// update pro
						// sprintf(printbufcomp,"%s",apObjectArray[dd].stringId);
						// sprintf(printbuf,"%s",ap.ssid);
						if (strcmp(apObjectArray[dd].stringId,ap.ssid)==0)
						{
							found=dd;
							// found the correct entry > store new data
							apObjectArray[dd].pro=pro;
						}
						/*
						if (i==0)
						{
							PA_OutputText(0,10,0+dd,printbuf);
							PA_OutputText(0,20,0+dd,printbufcomp);
						}
						*/
					} 
					
					// new entry
					if (found==-1)
					{
						// not the
						if (apObjectArrayMax>(apObjectArrayCount+3))
						{
							sprintf(apObjectArray[apObjectArrayCount].stringId,"%s",ap.ssid);
							apObjectArray[apObjectArrayCount].x=0;
							apObjectArray[apObjectArrayCount].y=0;
							apObjectArray[apObjectArrayCount].pro=0;
							apObjectArray[apObjectArrayCount].order=-1;
							apObjectArray[apObjectArrayCount].selected=0;
							// sprintf(apObjectArray[apObjectArrayCount].sound,"soundDie");
							apObjectArrayCount++;
						}
					}
				} // pro > 0
				
				// display % > 0
				if (pro>0) 
				{ 
					counterOverZero++;
					sprintf(printbuf,"%3i%:%s     ",pro,ap.ssid);
					// PA_OutputText(1,8,5+counterOverZero,printbuf); 
				}
				
			}
		}
		
		// -----------------------------------------
		// stringHiddenRaySong
		// -----------------------------------------
		// 2 different songs
		// loud: activ
		// more silent: inactiv
		
			// clean up notes
			int t=0;
			for (t=0;t<13;t++)
			{
				PA_OutputText(1,1,18-t,"                              "); 
			}
		
		int song=0;
		for (song=0;song<2;++song)
		{
			int displaySong=0;
			if ((song==0)&&(song1DisplayFlag==1)) displaySong=1;
			if ((song==1)&&(song2DisplayFlag==1)) displaySong=1;

			
			if (displaySong==1)
			{
				if (song==0) sprintf(stringHiddenRaySong,"%s", stringHiddenRaySongnotation1);
				if (song==1) sprintf(stringHiddenRaySong,"%s", stringHiddenRaySongnotation2);
		
					sprintf(printbuf,"%s",stringHiddenRaySong);
					// PA_OutputText(1,1,18,printbuf); 
					// play next char ..
					int actualChar='a';
					int actualNextChar='n';
					int z=0;
					int acc=strlen(stringHiddenRaySong);
					if (acc>25) acc=25;
					int count=0;
					for (z=0;z<acc;z++)
					{
						stringHiddenBuffer[count]=printbuf[z];	
						count++;
						if (z==6) { actualChar=printbuf[z+1]; if (z+2<strlen(stringHiddenBuffer)) { actualNextChar=printbuf[z+2]; } }
						/*
						if (z==5) 
						{
							stringHiddenBuffer[count]='[';
							count++;
						}
						if (z==6) 
						{
							stringHiddenBuffer[count]=']';
							count++;
						}
						*/
						// display notes
						displayNote(count, stringHiddenBuffer[count], stringHiddenBuffer[count+1]);
		
					}
					stringHiddenBuffer[count]='\0';
					
					// display chars up 
					PA_SetTextCol(1,7,7,7);
					if (song==0) PA_OutputText(1,1,songDisplayY,stringHiddenBuffer); 
					if (song==1) PA_OutputText(1,1,songDisplayY+1,stringHiddenBuffer); 
						 
					// play song
					int nextChar=0;
					
					// songcounter
					if (song==0) { hiddenRAySongCounter1++; if (hiddenRAySongCounter1>hiddenRaySpeed) { nextChar=1; hiddenRAySongCounter1=0; } }
					if (song==1) { hiddenRAySongCounter2++; if (hiddenRAySongCounter2>hiddenRaySpeed) { nextChar=1; hiddenRAySongCounter2=0; } }
					
					if (nextChar==1)
					{
						 
						// PA_GetFreeSoundChannel()  
						  
						// play char 
						PA_SetDefaultSound(127,11205,0); // volume 127,11025, 8-bit 
						// next char . || space 
						int longChar=1;
						if ((actualNextChar=='c')|| (actualNextChar=='C')) { longChar=0; }
						if ((actualNextChar=='d')|| (actualNextChar=='D')) { longChar=0; }
						if ((actualNextChar=='e')|| (actualNextChar=='E')) { longChar=0; }
						if ((actualNextChar=='f')|| (actualNextChar=='F')) { longChar=0; }
						if ((actualNextChar=='g')|| (actualNextChar=='G')) { longChar=0; }
						if ((actualNextChar=='a')|| (actualNextChar=='A')) { longChar=0; }
						if ((actualNextChar=='h')|| (actualNextChar=='H')) { longChar=0; }
						if ((actualNextChar=='b')|| (actualNextChar=='B')) { longChar=0; }
			
						// small sound
						if (longChar==0)
						{
							if (song==1) PA_SetDefaultSound(115,11025,0);
							if (actualChar=='c') PA_PlaySimpleSound(PA_GetFreeSoundChannel() , soundC);
							if (actualChar=='d') PA_PlaySimpleSound(PA_GetFreeSoundChannel() , soundD);
							if (actualChar=='e') PA_PlaySimpleSound(PA_GetFreeSoundChannel() , soundE);
							if (actualChar=='f') PA_PlaySimpleSound(PA_GetFreeSoundChannel() , soundF);
							if (actualChar=='g') PA_PlaySimpleSound(PA_GetFreeSoundChannel() , soundG);
							if (actualChar=='a') PA_PlaySimpleSound(PA_GetFreeSoundChannel() , soundA);
							if (actualChar=='h') PA_PlaySimpleSound(PA_GetFreeSoundChannel() , soundH);
							if (actualChar=='b') PA_PlaySimpleSound(PA_GetFreeSoundChannel() , soundB);
								// Long
							if (actualChar=='C') PA_PlaySimpleSound(PA_GetFreeSoundChannel() , soundCC);
							if (actualChar=='D') PA_PlaySimpleSound(PA_GetFreeSoundChannel() , soundDD);
							if (actualChar=='E') PA_PlaySimpleSound(PA_GetFreeSoundChannel() , soundEE);
							if (actualChar=='F') PA_PlaySimpleSound(PA_GetFreeSoundChannel() , soundFF);
							if (actualChar=='G') PA_PlaySimpleSound(PA_GetFreeSoundChannel() , soundGG);
							if (actualChar=='A') PA_PlaySimpleSound(PA_GetFreeSoundChannel() , soundAA);
							if (actualChar=='H') PA_PlaySimpleSound(PA_GetFreeSoundChannel() , soundHH);
							if (actualChar=='B') PA_PlaySimpleSound(PA_GetFreeSoundChannel() , soundBB);
						}	
						// long sound
						if (longChar==1)
						{
							if (song==1) PA_SetDefaultSound(115,11025,0);
							if (actualChar=='c') PA_PlaySimpleSound(PA_GetFreeSoundChannel() , soundCLong);
							if (actualChar=='d') PA_PlaySimpleSound(PA_GetFreeSoundChannel() , soundDLong);
							if (actualChar=='e') PA_PlaySimpleSound(PA_GetFreeSoundChannel() , soundELong);
							if (actualChar=='f') PA_PlaySimpleSound(PA_GetFreeSoundChannel() , soundFLong);
							if (actualChar=='g') PA_PlaySimpleSound(PA_GetFreeSoundChannel() , soundGLong);
							if (actualChar=='a') PA_PlaySimpleSound(PA_GetFreeSoundChannel() , soundALong);
							if (actualChar=='h') PA_PlaySimpleSound(PA_GetFreeSoundChannel() , soundHLong);
							if (actualChar=='b') PA_PlaySimpleSound(PA_GetFreeSoundChannel() , soundBLong);
								// Long
							if (actualChar=='C') PA_PlaySimpleSound(PA_GetFreeSoundChannel() , soundCCLong);
							if (actualChar=='D') PA_PlaySimpleSound(PA_GetFreeSoundChannel() , soundDDLong);
							if (actualChar=='E') PA_PlaySimpleSound(PA_GetFreeSoundChannel() , soundEELong);
							if (actualChar=='F') PA_PlaySimpleSound(PA_GetFreeSoundChannel() , soundFFLong);
							if (actualChar=='G') PA_PlaySimpleSound(PA_GetFreeSoundChannel() , soundGGLong);
							if (actualChar=='A') PA_PlaySimpleSound(PA_GetFreeSoundChannel() , soundAALong);
							if (actualChar=='H') PA_PlaySimpleSound(PA_GetFreeSoundChannel() , soundHHLong);
							if (actualChar=='B') PA_PlaySimpleSound(PA_GetFreeSoundChannel() , soundBBLong);
						}	
						
						// move left
						int len=strlen(stringHiddenRaySong);
						for (z=0;z<len;z++)
						{
							stringHiddenRaySong[z]=stringHiddenRaySong[z+1];
						}
						stringHiddenRaySong[z]='\0';
						stringHiddenRaySong[z+1]=' ';
					}
					
					// display played actual char
					// PA_SetTextCol(0,20,20,20);
					// sprintf(printbufcomp,"[%c]",actualChar);
					// PA_OutputText(0,7,17,printbufcomp); 

					
					// too small text - get new hotspot-names
					if (strlen(stringHiddenRaySong)<40)
					{


						// 0 as a background .. 
						if (apObjectArrayCount>0)
						{

							// actual place
							if (song==0)
							{
								// int index = (int) PA_RandMinMax(0,hotspotZeroIndex);
								int indexS = (int) PA_RandMinMax(0,hotspotZeroIndex);
								sprintf(stringHiddenRaySong,"%s%s ",stringHiddenRaySong,apObjectArray[indexS].stringId);
							}
							// history melody
							if (song==1)
							{
								int indexS = (int) PA_RandMinMax(0,apObjectArrayCount);
								sprintf(stringHiddenRaySong,"%s%s ",stringHiddenRaySong,apObjectArray[indexS].stringId);
							}
						}
					}

					
					// /stringHiddenRaySong
					if (song==0) sprintf(stringHiddenRaySongnotation1,"%s",stringHiddenRaySong);
					if (song==1) sprintf(stringHiddenRaySongnotation2,"%s",stringHiddenRaySong);
					
				
				} // display songs

			} // display all active songs
			

/*
// !!!!
		//ds specific, several attributes can be set here	
		glPolyFmt(POLY_ALPHA(31) | POLY_CULL_NONE);
		
		// Set the current matrix to be the model matrix
		glMatrixMode(GL_MODELVIEW);
		
		//Push our original Matrix onto the stack (save state)
		glPushMatrix();	

		glLoadIdentity();									// Reset The Current Modelview Matrix
			glTranslatef(-1.5f,0.0f,-6.0f);						// Move Left 1.5 Units And Into The Screen 6.0
			glBegin(GL_TRIANGLES);								// Drawing Using Triangles
				glVertex3f( 0.0f, 1.0f, 0.0f);					// Top
				glVertex3f(-1.0f,-1.0f, 0.0f);					// Bottom Left
				glVertex3f( 1.0f,-1.0f, 0.0f);					// Bottom Right
			glEnd();											// Finished Drawing The Triangle
			glTranslatef(3.0f,0.0f,0.0f);						// Move Right 3 Units
			glBegin(GL_QUADS);									// Draw A Quad
				glVertex3f(-1.0f, 1.0f, 0.0f);					// Top Left
				glVertex3f( 1.0f, 1.0f, 0.0f);					// Top Right
				glVertex3f( 1.0f,-1.0f, 0.0f);					// Bottom Right
				glVertex3f(-1.0f,-1.0f, 0.0f);					// Bottom Left
			glEnd();					
		// Pop our Matrix from the stack (restore state)
		glPopMatrix(1);

		//a handy little built in function to wait for a screen refresh
		
		
		// flush to screen	
		glFlush(0);
// !!!
*/

	// 	if(Pad.Newpress.Right) {	PA_PlaySimpleSound(0, soundCry); }// play sound 
	
		// Display dynamic Things
		
/*		
		// PALib problems with dswifi
		//PA_OutputText(1,0,9,"Stylus ?? [%d,%d]  %d  ", Stylus.X, Stylus.Y,angle);
		// mouse drag & drop sprite 0 on screen (defined up)
		PA_MoveSpritePix(0);
		
		// touched
		int i=0;
		for (i = 0; i < 16; i++) 
		{
			if (PA_SpriteTouched(i))
			{
				PA_OutputText(1,0,10,"Sprite Touched: %d   ", i);
	
			}
		}
*/
		
		// drag & drop with all sprites
		// for (i = 0; i < 16; i++) PA_MoveSprite(i);
		
		// set position direct
			// on coordinates
		//	PA_SetSpriteXY(screen, sprite, x, y);
			// stylus
		//	PA_SetSpriteXY(0,0,Stylus.X,Stylus.Y); 
		

		// PALIB don't works here >> use direct scan
		/*
		// move with cursors
			// first click
			if(Pad.Newpress.Right) {avatarX=avatarX+1; }
			
			// hold on
			if (Pad.Held.Right) { avatarX=avatarX+1;  }
			if (Pad.Held.Left) {  avatarX=avatarX-1; }
			if (Pad.Held.Up) {  avatarY=avatarY-1; }
			if (Pad.Held.Down) { avatarY=avatarY+1; }
			PA_SetSpriteXY(1,0,avatarX,avatarY);
		
			// rotating
			++angle; // change the angle
			angle &= 511; // limit the range to 0-511. works only with 1, 3, 7, 15, 31, etc... (2^n  - 1)
			
			// Fast function for rotations without zoom...
			PA_SetRotsetNoZoom(1, //screen
					   0, // rotset
					   angle); // angle, from 0 to 511
		*/
		
		
		
		// swiWaitForVBlank();
		PA_WaitForVBL();
	}
	
	Wifi_DisableWifi();
	// while(keysHeld()&KEY_TOUCH) WaitVbl();
	// WaitVbl();WaitVbl();

			
	return 0;
} // End of main()

	void displayNote(int pos, int note, int notenext)
	{
			// longChar 
		int longnote=0;	
		if ((note=='c')|| (notenext=='C')) { longnote=1; }
		if ((note=='d')|| (notenext=='D')) { longnote=1; }
		if ((note=='e')|| (notenext=='E')) { longnote=1; }
		if ((note=='f')|| (notenext=='F')) { longnote=1; }
		if ((note=='g')|| (notenext=='G')) { longnote=1; }
		if ((note=='a')|| (notenext=='A')) { longnote=1; }
		if ((note=='h')|| (notenext=='H')) { longnote=1; }
		if ((note=='b')|| (notenext=='B')) { longnote=1; }
	
		// if (longnote==1)
		int posx=pos+1;
		int posBase=18;
		int posy=posBase;
		// if (note=='c') posy=15;
		int displayF=0;
		if (note=='c') { posy=posBase; displayF=1; }
		if (note=='d') { posy=posBase-1; displayF=1; }
		if (note=='e') { posy=posBase-2; displayF=1; }
		if (note=='f') { posy=posBase-3; displayF=1; }
		if (note=='g') { posy=posBase-4; displayF=1; }
		if (note=='a') { posy=posBase-5; displayF=1; }
		if (note=='h') { posy=posBase-6; displayF=1; }
		if (note=='b') { posy=posBase-6; displayF=1; }

			if (note=='C') { posy=posBase-6; displayF=1; }
			if (note=='D') { posy=posBase-6-1; displayF=1; }
			if (note=='E') { posy=posBase-6-2; displayF=1; }
			if (note=='F') { posy=posBase-6-3; displayF=1; }
			if (note=='G') { posy=posBase-6-4; displayF=1; }
			if (note=='H') { posy=posBase-6-5; displayF=1; }
			if (note=='A') { posy=posBase-6-6; displayF=1; }
			if (note=='B') { posy=posBase-6-6; displayF=1; }
		
		if (displayF) 
		{ 
		   // display now?
		   if (songNotesDisplay)
		   {
				if (longnote==0) PA_OutputText(1,posx,posy,"o"); 
				else PA_OutputText(1,posx,posy,"*"); 	
			}
		}

	}

// keyboard
void getTextboard( char text[200] )
{
		PA_Init();    // Initializes PA_Lib
		PA_InitVBL(); // Initializes a standard VBL
			
		PA_InitText(1, 0);  // Initialise the text system
			
		PA_InitKeyboard(2); // Load the keyboard on background 2...
			
		PA_KeyboardIn(20, 100); // This scrolls the keyboard from the bottom, until it's at the right position
			
		PA_OutputSimpleText(1, 7, 10, "Text : "); 
			
		s32 nletter = 0; // Next letter to right. 0 since no letters are there yet
		char letter = 0; // New letter to write.
		// char text[200];  // This will be our text.
			
		// Infinite loop to keep the program running
		while (1)
		{
			// We'll check first for color changes, with A, B, and X
			if (Pad.Newpress.A) PA_SetKeyboardColor(0, 1); // Blue and Red
			if (Pad.Newpress.B) PA_SetKeyboardColor(1, 0); // Red and Blue
			if (Pad.Newpress.X) PA_SetKeyboardColor(2, 1); // Green and Red
			if (Pad.Newpress.Y) PA_SetKeyboardColor(0, 2); // Blue and Green
				
			letter = PA_CheckKeyboard();
				
			if (letter > 31) { // there is a new letter
				text[nletter] = letter;
				nletter++;
			}
			else if ((letter == PA_BACKSPACE)&&nletter) { // Backspace pressed
				nletter--;
				text[nletter] = ' '; // Erase the last letter
			}
			else if (letter == '\n'){ // Enter pressed
				text[nletter] = letter;
				nletter++;
				break;
			}
				
			PA_OutputSimpleText(1, 8, 11, text); // Write the text
			PA_WaitForVBL();
		}
		
}

void Timer_50ms(void) {
   Wifi_Timer(1);
//   Wifi_Timer(50);
}

void arm9_synctoarm7() { // send fifo message
   REG_IPC_FIFO_TX=0x87654321;
}
void arm9_fifo() { // check incoming fifo messages
   u32 value = REG_IPC_FIFO_RX;
   if(value == 0x87654321) Wifi_Sync();
}